<?php
/***************************************************************
 *  Copyright notice
 *  Development 2009 by BVB Media BV the Netherlands <sales@bvbmedia.nl>
 *  Author: Bas van Beek <bvbmedia@gmail.com>
 *  All rights reserved.
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 * Hint: use extdeveval to insert/update function index above.
 */
$LANG->includeLLFile('EXT:find_and_replace/mod1/locallang.xml');
//require_once(PATH_t3lib.'class.t3lib_scbase.php');
$BE_USER->modAccess($MCONF, 1); // This checks permissions and exits if the users has no permission for entry.
// DEFAULT initialization of a module [END]
/**
 * Module 'Content Replacer' for the 'find_and_replace' extension.
 * @author    BVB Media BV. the Netherlands <bvbmedia@gmail.com>
 * @package    TYPO3
 * @subpackage    tx_find_and_replace
 */
class  tx_find_and_replace_module1 extends t3lib_SCbase {
	var $pageinfo;
	/**
	 * Initializes the Module
	 * @return    void
	 */
	function init() {
		global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;
		parent::init();
		/*
		if (t3lib_div::_GP('clear_all_cache'))	{
			$this->include_once[] = PATH_t3lib.'class.t3lib_tcemain.php';
		}
		*/
	}
	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 * @return    void
	 */
	function menuConfig() {
		global $LANG;
		$this->MOD_MENU=Array();
		parent::menuConfig();
	}
	/**
	 * Defines the types
	 * @return    void
	 */
	function loadConfiguration() {
		$this->conf['max_input_vars']=ini_get('max_input_vars');
		$this->get=t3lib_div::_GET();
		$this->post=t3lib_div::_POST();
		$this->FULL_HTTP_URL=t3lib_div::getIndpEnv('TYPO3_SITE_URL').t3lib_extMgm::siteRelPath('find_and_replace');
		$this->enabledTables=array();
		$this->enabledColumns=array();
		$this->excludedTables=array();
		$this->excludedColumns=array();
		$this->excludedTables[]='cache_extensions';
		$this->excludedTables[]='cache_imagesizes';
		$this->excludedTables[]='cache_md5params';
		$this->excludedTables[]='cache_treelist';
		$this->excludedTables[]='cache_typo3temp_log';
		$this->excludedTables[]='cf_cache_hash';
		$this->excludedTables[]='cf_cache_hash_tags';
		$this->excludedTables[]='cf_cache_pages';
		$this->excludedTables[]='cf_cache_pagesection';
		$this->excludedTables[]='cf_cache_pagesection_tags';
		$this->excludedTables[]='cf_cache_pages_tags';
		$this->excludedTables[]='cf_extbase_object';
		$this->excludedTables[]='cf_extbase_object_tags';
		$this->excludedTables[]='cf_extbase_reflection';
		$this->excludedTables[]='cf_extbase_reflection_tags';
		$this->excludedTables[]='cf_workspaces_cache';
		$this->excludedTables[]='cf_workspaces_cache_tags';
		$this->excludedTables[]='be_sessions';
		$this->excludedTables[]='be_groups';
		// load tables dynamically
		/*
		$str='SHOW tables';
		$res=$GLOBALS['TYPO3_DB']->sql_query($str);
		while($row = $GLOBALS['TYPO3_DB']->sql_fetch_row($res)) {
			if (!in_array($row[0],$this->excludedTables)) {
				$this->enabledTables[]=$row[0];
			}

		}
		*/
		// define statically
		$this->enabledTables=array();
		$this->enabledTables[]='pages';
		$this->enabledTables[]='pages_language_overlay';
		$this->enabledTables[]='tt_content';
		$this->enabledTables[]='sys_template';
		$this->enabledTables[]='sys_domain';
		$this->enabledTables[]='tx_multishop_configuration';
		$this->enabledTables[]='tx_multishop_configuration_values';
		// sort table names
		asort($this->enabledTables);
		// get the columns
		foreach ($this->enabledTables as $table) {
			$str='SHOW fields from '.$table;
			$res=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_row($res)) {
				if (!in_array($row[0], $this->excludedColumns)) {
					$this->enabledColumns[$table][]=$row[0];
				}
			}
			asort($this->enabledColumns[$table]);
		}
	}
	/**
	 * Main function of the module. Write the content to $this->content
	 * If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	 * @return    [type]        ...
	 */
	function main() {
		global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;
		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo=t3lib_BEfunc::readPageAccess($this->id, $this->perms_clause);
		$access=is_array($this->pageinfo) ? 1 : 0;
		// initialize doc
		$version=class_exists('t3lib_utility_VersionNumber') ? t3lib_utility_VersionNumber::convertVersionNumberToInteger(TYPO3_version) : t3lib_div::int_from_ver(TYPO3_version);
		if ($version>=6000000) {
			$this->doc=\TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Backend\\Template\\DocumentTemplate');
		} else {
			$this->doc=t3lib_div::makeInstance('template');
		}
		$this->doc->setModuleTemplate(t3lib_extMgm::extPath('find_and_replace').'mod1/mod_template.html');
		$this->doc->backPath=$BACK_PATH;
		$docHeaderButtons=$this->getButtons();
		self::loadConfiguration();
		$this->doc->JScode='
							<style type="text/css"> 
							/*<![CDATA[*/
							<!-- 
							/*inDocStyles*/
							 
							 
							/*###POSTCSSMARKER###*/
							-->
							/*]]>*/
							.floated_ul {
								width:\'100%\';
							} 
							.floated_ul li {
								width:250px;
								float:left;
							}
							.floated_ul li input {
								width:50px; text-align:left;
							}							
							.floated_ul li label {
								display: inline-block;
							}
							#top_nav {
								width:100%;overflow:hidden;list-style-type: none;
							}
							#top_nav li {
								float:left;font-family: Arial, Helvetica, sans-serif;	font-size: 14px;	font-weight: bold;	color: #FFF;	 margin-right:5px; 
							}		
							.tableItemWrapper {
								width:100%;
								clear:both;
								padding-bottom:30px;
								margin-bottom:30px;
							}
							.sr-wrap {
								width:100%;
								clear:both;
								padding-bottom:10px;
							}
							.shadow_bottom {
							overflow:hidden;
							width:100%;
							background:url(\''.$this->FULL_HTTP_URL.'mod1/images/shadow_bottom.png\') left bottom no-repeat;
							padding:0 0 35px;
							}
							fieldset {
							display:block;
							border:1px solid #999;
							background:#fff;
							margin:10px 0 0;
							padding:10px 10px 10px;
							}
							fieldset legend {
							background:#585858;
							color:#fff;
							font-family:Verdana,Arial,Helvetica,sans-serif;
							font-size:11px;
							padding:2px 4px;
							}
							fieldset legend a
							{
								color:#fff;
							}
							fieldset legend a:hover
							{
								color:#fff;
								text-decoration:underline;
							}							 
							ul {
							list-style:none;
							margin:0;
							padding:0;
							}
							</style> 						
							<!--[if IE]>
							<style>
							fieldset {
							position: relative;
							padding-top:15px;
							margin:20px 0 0;
							}
							legend {
							position: absolute;
							top: -10px;
							left: 10px;
							}
							</style>
							<![endif]-->			
					<script>
					function CONFIRM(label)
					{
									if (confirm(label))
									{
										return true;
									}
									else
									{
										return false;
									}
					}					
					function showmenu(listID)
					{
						if (listID==\'tab1\')
						{
							document.getElementById(\'tab1\').style.display = "";
							document.getElementById(\'tab2\').style.display = "none";
							document.getElementById(\'tab3\').style.display = "none";
						}
						else if (listID==\'tab2\')
						{
							document.getElementById(\'tab1\').style.display = "none";
							document.getElementById(\'tab2\').style.display = "";
							document.getElementById(\'tab3\').style.display = "none";
						}
						else if (listID==\'tab3\')
						{
							document.getElementById(\'tab1\').style.display = "none";
							document.getElementById(\'tab2\').style.display = "none";
							document.getElementById(\'tab3\').style.display = "";
						}						
					}
					</script>
					';
		if (($this->id && $access) || ($BE_USER->user['admin'] && !$this->id)) {
			// Draw the form
			$this->doc->form='<form action="" id="find_and_replace" name="find_and_replace" method="post" enctype="multipart/form-data">';
			/*
									$this->doc->inDocStylesArray[] ='
										.sr-wrap div{ clear:left;overflow:hidden}
										.sr-wrap div label{float:left;width:180px;font-weight:bold}
										.sr-wrap div label.spacer{float:left;width:20px;}
									';
			*/
			// Render content:
			$this->moduleContent();
		} else {
			// If no access or if ID == zero
			$docHeaderButtons['save']='';
			$this->content.=$this->doc->spacer(10);
		}
		// compile document
		//$markers['FUNC_MENU'] = t3lib_BEfunc::getFuncMenu(0, 'SET[function]', $this->MOD_SETTINGS['function'], $this->MOD_MENU['function']);
		$markers['FUNC_MENU']='<h1>Find and Replace</h1>';
		$markers['CONTENT']=$this->content;
		// Build the <body> for the module
		$this->content=$this->doc->startPage($LANG->getLL('title'));
		$this->content.=$this->doc->moduleBody($this->pageinfo, $docHeaderButtons, $markers);
		//	$this->content.= $this->doc->endPage();
		$this->content=$this->doc->insertStylesAndJS($this->content);
	}
	/**
	 * Prints out the module HTML
	 * @return    void
	 */
	function printContent() {
		$this->content.=$this->doc->endPage();
		echo $this->content;
	}
	/**
	 * Generates the module content
	 * @return    void
	 */
	function moduleContent() {
		$content.='
					<a name="gotoTop">&nbsp;</a>
					<a href="#gotoBottom">Goto bottom</a>';
		if ($this->post && $this->post['reptext']=='UPDATE') {
			$content.=$this->replaceText();
		}
		$content.=$this->searchText();
		$this->content.=$this->doc->section('', $content, 0, 1);
	}
	function buildPageTree() {
		$pages=$this->getPageTree();
		$tree='<select name="pid" style="width:350px">
					<option value="0">Everything</option>';
		foreach ($pages as $pid=>$title) {
			$tree.='<option value="'.$pid.'">'.$title.'</option>'."\n";
		}
		$tree.='</select>'."\n";
		return $tree;
	}
	protected function getPageTree($pid='0', $pages=array(), $times=0) {
		$res=$GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,title', 'pages', 'hidden = 0 and deleted = 0 and pid='.$pid.'', '');
		$times++;
		while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			$pages[$row['uid']]=str_repeat("-", $times-1)."-[ ".$row['title'];
			$pages=$this->getPageTree($row['uid'], $pages, $times);
		}
		$times--;
		return $pages;
	}
	protected function searchText() {
		$content.='
					<script src="'.$this->FULL_HTTP_URL.'res/jquery-1.10.1.min.js" type="text/javascript"></script>
					<script type="text/javascript">
						$.noConflict();
					</script>
					<script language=javascript>
					jQuery(function ($) {						
						$(\'.checkall\').on(\'click\', function () {
							$(this).closest(\'ul\').find(\':checkbox\').prop(\'checked\', this.checked);
						});
						$(\'.checkallGlobal\').on(\'click\', function () {
							var that_checked=this.checked;
							$(\'.checkall\').each(function(index) {
								$(this).closest(\'ul\').find(\':checkbox\').prop(\'checked\', that_checked);
							});							
						});
						
					});
					</script>					
	<div class="shadow_bottom">
		<fieldset>					
					<div class="sr-wrap">
						<div>
							<label>Startingpoint (if appropriate) </label><label class="spacer">: </label>
							'.$this->buildPageTree().'
						</div>
					</div>
					<div class="sr-wrap">
						<div>
							<label>Which table colums do you like to adjust</label><label class="spacer">: </label>
							<table width="100%">
								<tr>
									<td>
									
';
		$totalChecboxes=0;
		foreach ($this->enabledTables as $table) {
			if (count($this->enabledColumns[$table])) {
				$content.='<div class="tableItemWrapper">';
				$content.='<h4>Table: '.htmlspecialchars($table).'</h4>';
				$content.='<ul class="floated_ul" id="ulTable_'.$table.'">';
				$content.='<li class="lastLiCheckall">
			<input type="checkbox" name="checkall" id="'.htmlspecialchars($table.'_'.$column.'checkall').'" class="checkall"><label for="'.htmlspecialchars($table.'_'.$column.'checkall').'">Select all / deselect all</label>
		</li>';
				foreach ($this->enabledColumns[$table] as $column) {
					$totalChecboxes++;
					$content.='<li>
			<input name="selectedColumns[]" id="'.htmlspecialchars($table.'_'.$column).'" type="checkbox" value="'.htmlspecialchars($table.'::'.$column).'"'.(in_array($table.'::'.$column, $this->post['selectedColumns']) ? ' checked' : '').' /><label for="'.htmlspecialchars($table.'_'.$column).'">'.htmlspecialchars($column).'</label>
			</li>';
				}
				$content.='</ul>';
				$content.='</div>';
			}
		}
		$content.='
									</td>
								</tr>
							</table>
						</div>
					</div>		
					';
		$content.='
					<div id="tab1">
										<div class="sr-wrap">
											<div>

												<input type="checkbox" name="checkall" id="checkallGlobal" class="checkallGlobal"><label for="checkallGlobal">Select all / deselect all</label>
											</div><br />										
											<div>
												<label>Search for </label><label class="spacer">: </label>
												<textarea name="find_text" style="width:100%" rows="5">'.htmlspecialchars($this->post['find_text']).'</textarea>
											</div><br />
											<div>
												<label>Replace with </label><label class="spacer">: </label>
												<textarea name="replace_text" style="width:100%" rows="5">'.htmlspecialchars($this->post['replace_text']).'</textarea>
											</div><br />
										</div>
					</div>		
					<div class="sr-wrap">
						<div>
';
		ini_set("max_input_vars", $totalChecboxes);
		if (($totalChecboxes+200)>$this->conf['max_input_vars']) {
			$content.='<h3>WARNING</h3>The PHP setting MAX_INPUT_VARS is configured to: '.$this->conf['max_input_vars'].'.<br />This means you cannot select all ('.$totalChecboxes.') checkboxes without first adjusting the PHP configuration.<br /><br />
	
To fix it add this to the .htaccess file:<br />

#allow all selected checkboxes to be submitted by TYPO3 / Find And Replace Utility<br />
php_value max_input_vars '.($totalChecboxes+200).'<br /><br /><br />

If .htaccess wont work add this to your vhost configuration file:<br /><br />

#allow all selected checkboxes to be submitted by TYPO3 / Find And Replace Utility<br />
max_input_vars='.($totalChecboxes+200).'<br /><br /><br />
	
	';
		}
		$content.='
					<ul id="top_nav">
						<li><input type="submit"  style="font-weight: bold;" name="reptext" value="UPDATE" onClick="return CONFIRM(\'WARNING: ONE MISTAKE LEADS TO A CORRUPT DATABASE. ONLY USE THIS TOOL IF YOU KNOW WHAT YOU ARE DOING. ARE YOU 100% SURE YOU WANT TO CONTINUE? \')" ></li>
					</ul>
					<BR>
					</div>
					</div>
										
					</fieldset></div>
<a href="#gotoTop">Goto top</a><br />
<div style="text-align:center;width:450px;">
<a title="created by BVB Media BV" href="http://www.bvbmedia.com/?utm_source=find_and_replace_backend&utm_medium=cpc&utm_term=find_and_replace&utm_content=Listing&utm_campaign=find_and_replace" target="_blank">created by BVB Media BV</a><br>
						webdevelopment by <a href="http://www.basvanbeek.nl/?utm_source=find_and_replace_backend&utm_medium=cpc&utm_term=find_and_replace&utm_content=Listing&utm_campaign=find_and_replace" target="_blank">Bas van Beek</a> - <a href="mailto:bvbmedia@gmail.com">bvbmedia@gmail.com</a><br>
</div>						
<a name="gotoBottom">&nbsp;</a>
					';
		return $content;
	}
	protected function replaceText() {
		$pids=array();
		$stats=array();
		if (is_numeric($this->post['pid']) and $this->post['pid']>0) {
			$pids=$this->getPageTree($this->post['pid']);
			$pids[$this->post['pid']]='parent';
		}
		if (is_array($this->post['selectedColumns']) and count($this->post['selectedColumns']) and $this->post['find_text']) {
			foreach ($this->post['selectedColumns'] as $selectedColumn) {
				$queries=array();
				$data=explode("::", $selectedColumn);
				if ($data[0] and $data[1]) {
					$str="update `".$data[0]."` set ".$data[1]."=replace(".$data[1].",'".mysql_escape_string($this->post['find_text'])."','".mysql_escape_string($this->post['replace_text'])."')";
					if (in_array('pid', $this->enabledColumns[$data[0]]) and count($pids)) {
						foreach ($pids as $key=>$value) {
							$queries[]=$str." where pid='".$key."'";
						}
					} else {
						$queries[]=$str;
					}
					if (count($queries)) {
						foreach ($queries as $query) {
							$res=$GLOBALS['TYPO3_DB']->sql_query($query);
							$total=mysql_affected_rows();
							if ($total>0) {
								$stats['positive'][$data[0].'.'.$data[1]]=((int)$stats['positive'][$data[0].'.'.$data[1]])+$total;
							} else {
								$stats['negative'][$data[0].'.'.$data[1]]=((int)$stats['negative'][$data[0].'.'.$data[1]])+$total;
							}
						}
					}
				}
			}
		}
		if (is_array($stats) and count($stats)) {
			$content.='<h1>Results</h1>
						';
			$mode='positive';
			if (is_array($stats[$mode]) and count($stats[$mode])) {
				foreach ($stats[$mode] as $tableColumn=>$score) {
					$content.='<strong>'.$score.'</strong> records has been adjusted in <strong>'.$tableColumn.'</strong>.<BR>';
				}
			}
			$mode='negative';
			if (is_array($stats[$mode]) and count($stats[$mode])) {
				foreach ($stats[$mode] as $tableColumn=>$score) {
					$content.='<strong>'.$score.'</strong> records has been adjusted in <strong>'.$tableColumn.'</strong>.<BR>';
				}
			}
		}
		return $content;
	}
	/**
	 * Create the panel of buttons for submitting the form or otherwise perform operations.
	 * @return    array    all available buttons as an assoc. array
	 */
	protected function getButtons() {
		$buttons=array(
			'csh'=>'',
			'shortcut'=>'',
			'save'=>''
		);
		// CSH
		$buttons['csh']=t3lib_BEfunc::cshItem('_MOD_web_func', '', $GLOBALS['BACK_PATH']);
		// Shortcut
		if ($GLOBALS['BE_USER']->mayMakeShortcut()) {
			$buttons['shortcut']=$this->doc->makeShortcutIcon('', 'function', $this->MCONF['name']);
		}
		return $buttons;
	}
}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/find_and_replace/mod1/index.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/find_and_replace/mod1/index.php']);
}
// Make instance:
$SOBE=t3lib_div::makeInstance('tx_find_and_replace_module1');
$SOBE->init();
// Include files?
foreach ($SOBE->include_once as $INC_FILE) {
	include_once($INC_FILE);
}
$SOBE->main();
$SOBE->printContent();
?>